/* 
 * File:   esp8266.h
 * Author: Sasch
 *
 * Created on August 28, 2018, 6:15 PM
 */

#ifndef ESP8266_H
#define	ESP8266_H

#ifdef	__cplusplus
extern "C" {
#endif

//wifi connections settings
const char ssid[] = "SSIS";
const char passwd[] = "Passwort";

#define BUFFER_FAIL     0
#define BUFFER_SUCCESS  1

#define BUFFER_SIZE 2048
#define BUFFER_MASK (BUFFER_SIZE-1) // Klammern auf keinen Fall vergessen


struct Buffer {
  uint8_t data[BUFFER_SIZE];
  volatile uint8_t read; // zeigt auf das Feld mit dem ltesten Inhalt
  volatile uint8_t write; // zeigt immer auf leeres Feld
  volatile uint16_t count;
};

extern struct Buffer buffer;

uint8_t BufferIn(uint8_t byte);
uint8_t BufferOut(uint8_t *pByte);
void Uart_Interrupt(void);
void init_esp8266(void);
inline char BufferAvailable(void);
inline void BufferClr(void);
char ReadLnBuffer(char* data);
char ReadBuffer(char* data, uint16_t len);
char ReadcBuffer(void);
char SearchBuffer(const char* search);
char SearchBuffer2(const char* search);
void PutsUART(const char* str);
void PutssUART(char* str);
void PutcUART(char str);
// <meta http-equiv=\"refresh\" content=\"4\" >
const char page0[]=
{
"<html><head><title>PIC18F & ESP8266 Webserver</title></head><h1>PIC18F & ESP8266 Webserver</h1>"
"<p><hr></p>"
"<body><p><form method=\"GET\"></p>"
"<p><input type=\"submit\" name=\"B\" value=\"1\" > LED1 ON"
};
const char page01[]={"  LED 1 ist <FONT SIZE=\"5\" COLOR=\"#00FF00\">an</FONT></p>"};
const char page02[]={"  LED 1 ist <FONT SIZE=\"5\" COLOR=\"#FF000\">aus</FONT></p>"};
const char page03[]={
"<p><input type=\"submit\" name=\"B\" value=\"2\" > LED1 OFF</p>"
"<p><input type=\"submit\" name=\"B\" value=\"3\" > LED2 ON"
};
const char page04[]={"  LED 2 ist <FONT SIZE=\"5\" COLOR=\"#00FF00\">an</FONT></p>"};
const char page05[]={"  LED 2 ist <FONT SIZE=\"5\" COLOR=\"#FF0000\">aus</FONT></p>"};
const char page06[]={    
"<p><input type=\"submit\" name=\"B\" value=\"4\" > LED2 OFF</p>"
"</p></body></html>\r\n"
};
#ifdef	__cplusplus
}
#endif

#endif	/* ESP8266_H */

